Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/GtpVisibility.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/GtpVisibility.vcproj	(revision 657)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/GtpVisibility.vcproj	(revision 662)
@@ -135,57 +135,57 @@
 				RelativePath="..\src\VisibilityManager.cpp">
 			</File>
-		</Filter>
-		<Filter
-			Name="Header Files"
-			Filter="h;hpp;hxx;hm;inl;inc;xsd"
-			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
-			<File
-				RelativePath="..\include\BatchedQueriesCullingManager.h">
-			</File>
-			<File
-				RelativePath="..\include\CoherentHierarchicalCullingManager.h">
-			</File>
-			<File
-				RelativePath="..\include\CullingManager.h">
-			</File>
-			<File
-				RelativePath="..\include\DistanceQueue.h">
-			</File>
-			<File
-				RelativePath="..\include\DummyPreprocessingManager.h">
-			</File>
-			<File
-				RelativePath="..\include\DummyQueryManager.h">
-			</File>
-			<File
-				RelativePath="..\include\FrustumCullingManager.h">
-			</File>
-			<File
-				RelativePath="..\include\HierarchyInterface.h">
-			</File>
-			<File
-				RelativePath="..\include\OcclusionQuery.h">
-			</File>
-			<File
-				RelativePath="..\include\PreprocessingManager.h">
-			</File>
-			<File
-				RelativePath="..\include\QueryManager.h">
-			</File>
-			<File
-				RelativePath="..\include\StopAndWaitCullingManager.h">
-			</File>
-			<File
-				RelativePath="..\include\VisibilityEnvironment.h">
-			</File>
-			<File
-				RelativePath="..\include\VisibilityInfo.h">
-			</File>
-			<File
-				RelativePath="..\include\VisibilityManager.h">
-			</File>
-			<File
-				RelativePath="..\include\VisibilityMesh.h">
-			</File>
+			<Filter
+				Name="Header Files"
+				Filter="h;hpp;hxx;hm;inl;inc;xsd"
+				UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+				<File
+					RelativePath="..\include\BatchedQueriesCullingManager.h">
+				</File>
+				<File
+					RelativePath="..\include\CoherentHierarchicalCullingManager.h">
+				</File>
+				<File
+					RelativePath="..\include\CullingManager.h">
+				</File>
+				<File
+					RelativePath="..\include\DistanceQueue.h">
+				</File>
+				<File
+					RelativePath="..\include\DummyPreprocessingManager.h">
+				</File>
+				<File
+					RelativePath="..\include\DummyQueryManager.h">
+				</File>
+				<File
+					RelativePath="..\include\FrustumCullingManager.h">
+				</File>
+				<File
+					RelativePath="..\include\HierarchyInterface.h">
+				</File>
+				<File
+					RelativePath="..\include\OcclusionQuery.h">
+				</File>
+				<File
+					RelativePath="..\include\PreprocessingManager.h">
+				</File>
+				<File
+					RelativePath="..\include\QueryManager.h">
+				</File>
+				<File
+					RelativePath="..\include\StopAndWaitCullingManager.h">
+				</File>
+				<File
+					RelativePath="..\include\VisibilityEnvironment.h">
+				</File>
+				<File
+					RelativePath="..\include\VisibilityInfo.h">
+				</File>
+				<File
+					RelativePath="..\include\VisibilityManager.h">
+				</File>
+				<File
+					RelativePath="..\include\VisibilityMesh.h">
+				</File>
+			</Filter>
 		</Filter>
 		<File
Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/default.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/default.env	(revision 661)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/default.env	(revision 662)
@@ -223,9 +223,4 @@
 	}
 
-	Evaluation {
-		samplesPerPass 300000
-		samples 8000000
-	}
-
 	Visualization {
 		# how much samples we use for visualization
@@ -238,8 +233,12 @@
 		exportGeometry true
 		exportMergedViewCells false
-		useCuttingPlane true
-		cuttingPlaneAxis 1
-	}
-	
+		useClipPlane true
+		clipPlaneAxis 1
+	}
+	
+	Evaluation {
+		samplesPerPass 200000
+		samples 2000000
+	}
 #	filename ../data/atlanta/atlanta_viewcells_large.x3d
 #	filename ../data/vienna/viewcells-25-sel.x3d
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 660)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 662)
@@ -1204,5 +1204,10 @@
 			optString,
 			"view_cells_type",
-			"bspTree");
+			"vspBspTree");
+
+	RegisterOption("ViewCells.samplingType",
+			optString,
+			"view_cells_sampling_type",
+			"box");
 
 	RegisterOption("ViewCells.stats",
@@ -1215,9 +1220,4 @@
 					"view_cells_stats_prefix=",
 					"viewCells");
-
-
-	RegisterOption("ViewCells.active",
-					optInt,
-					"1000");
 	
 	RegisterOption("ViewCells.active",
@@ -1230,4 +1230,36 @@
 					"5000000");
 
+
+	RegisterOption("ViewCells.Construction.samplesPerPass",
+					optInt,
+					"view_cells_construction_samples_per_pass=",
+					"500000");
+
+	RegisterOption("ViewCells.PostProcess.samples",
+					optInt,
+					"view_cells_postprocess_samples=",
+					"200000");
+
+	RegisterOption("ViewCells.Visualization.samples",
+					optInt,
+					"view_cells_visualization_samples=",
+					"20000");
+
+	RegisterOption("ViewCells.loadFromFile",
+					optBool,
+					"view_cells_load_from_file",
+					"false");
+
+	RegisterOption("ViewCells.PostProcess.refine",
+					optBool,
+					"view_cells_refine",
+					"false");
+
+
+	RegisterOption("ViewCells.PostProcess.compress",
+					optBool,
+					"view_cells_compress",
+					"false");
+
 	RegisterOption("ViewCells.Evaluation.samples",
 					optInt,
@@ -1237,37 +1269,7 @@
 	RegisterOption("ViewCells.Evaluation.samplesPerPass",
 					optInt,
-					"view_cells_evaluation_samples_per_oass=",
+					"view_cells_evaluation_samples_per_pass=",
 					"300000");
 
-	RegisterOption("ViewCells.Construction.samplesPerPass",
-					optInt,
-					"view_cells_construction_samples_per_pass=",
-					"500000");
-
-	RegisterOption("ViewCells.PostProcess.samples",
-					optInt,
-					"view_cells_postprocess_samples=",
-					"200000");
-
-	RegisterOption("ViewCells.Visualization.samples",
-					optInt,
-					"view_cells_visualization_samples=",
-					"20000");
-
-	RegisterOption("ViewCells.loadFromFile",
-					optBool,
-					"view_cells_load_from_file",
-					"false");
-
-	RegisterOption("ViewCells.PostProcess.refine",
-					optBool,
-					"view_cells_refine",
-					"false");
-
-
-	RegisterOption("ViewCells.PostProcess.compress",
-					optBool,
-					"view_cells_compress",
-					"false");
 
 	RegisterOption("ViewCells.exportToFile",